local wm = GetWindowManager()
local LAM = LibStub:GetLibrary("LibAddonMenu-1.0")
     
local arrForward = wm:CreateTopLevelWindow(nil)
arrForward:SetDimensions(128,128)
arrForward:SetAnchor(CENTER,GuiRoot,CENTER,-100,0)
arrForward.icon = wm:CreateControl(nil, arrForward, CT_TEXTURE)
arrForward.icon:SetTexture("FollowTheLeader/media/forward.dds")
arrForward.icon:SetAnchorFill(arrForward) 
arrForward.icon:SetHidden(true)

local arrForwardLeft = wm:CreateTopLevelWindow(nil)
arrForwardLeft:SetDimensions(128,128)
arrForwardLeft:SetAnchor(CENTER,GuiRoot,CENTER,-100,0)
arrForwardLeft.icon = wm:CreateControl(nil, arrForwardLeft, CT_TEXTURE)
arrForwardLeft.icon:SetTexture("FollowTheLeader/media/forwardleft.dds")
arrForwardLeft.icon:SetAnchorFill(arrForwardLeft) 
arrForwardLeft.icon:SetHidden(true)

local arrForwardRight = wm:CreateTopLevelWindow(nil)
arrForwardRight:SetDimensions(128,128)
arrForwardRight:SetAnchor(CENTER,GuiRoot,CENTER,-100,0)
arrForwardRight.icon = wm:CreateControl(nil, arrForwardRight, CT_TEXTURE)
arrForwardRight.icon:SetTexture("FollowTheLeader/media/forwardright.dds")
arrForwardRight.icon:SetAnchorFill(arrForwardRight) 
arrForwardRight.icon:SetHidden(true)

local arrRight = wm:CreateTopLevelWindow(nil)
arrRight:SetDimensions(128,128)
arrRight:SetAnchor(CENTER,GuiRoot,CENTER,-100,0)
arrRight.icon = wm:CreateControl(nil, arrRight, CT_TEXTURE)
arrRight.icon:SetTexture("FollowTheLeader/media/right.dds")
arrRight.icon:SetAnchorFill(arrRight) 
arrRight.icon:SetHidden(true)

local arrLeft = wm:CreateTopLevelWindow(nil)
arrLeft:SetDimensions(128,128)
arrLeft:SetAnchor(CENTER,GuiRoot,CENTER,-100,0)
arrLeft.icon = wm:CreateControl(nil, arrLeft, CT_TEXTURE)
arrLeft.icon:SetTexture("FollowTheLeader/media/left.dds")
arrLeft.icon:SetAnchorFill(arrLeft) 
arrLeft.icon:SetHidden(true)


local arrBackLeft = wm:CreateTopLevelWindow(nil)
arrBackLeft:SetDimensions(128,128)
arrBackLeft:SetAnchor(CENTER,GuiRoot,CENTER,-100,0)
arrBackLeft.icon = wm:CreateControl(nil, arrBackLeft, CT_TEXTURE)
arrBackLeft.icon:SetTexture("FollowTheLeader/media/backleft.dds")
arrBackLeft.icon:SetAnchorFill(arrBackLeft) 
arrBackLeft.icon:SetHidden(true)

local arrBackRight = wm:CreateTopLevelWindow(nil)
arrBackRight:SetDimensions(128,128)
arrBackRight:SetAnchor(CENTER,GuiRoot,CENTER,-100,0)
arrBackRight.icon = wm:CreateControl(nil, arrBackRight, CT_TEXTURE)
arrBackRight.icon:SetTexture("FollowTheLeader/media/backright.dds")
arrBackRight.icon:SetAnchorFill(arrBackRight) 
arrBackRight.icon:SetHidden(true)

local arrBack = wm:CreateTopLevelWindow(nil)
arrBack:SetDimensions(128,128)
arrBack:SetAnchor(CENTER,GuiRoot,CENTER,-100,0)
arrBack.icon = wm:CreateControl(nil, arrBack , CT_TEXTURE)
arrBack.icon:SetTexture("FollowTheLeader/media/back.dds")
arrBack.icon:SetAnchorFill(arrBack) 
arrBack.icon:SetHidden(true)

local BufferTable = {}

function BufferReached(key, buffer)
    if key == nil then return end
    if BufferTable[key] == nil then BufferTable[key] = {} end
    BufferTable[key].buffer = buffer or 3
    BufferTable[key].now = GetFrameTimeSeconds()
    if BufferTable[key].last == nil then BufferTable[key].last = BufferTable[key].now end
    BufferTable[key].diff = BufferTable[key].now - BufferTable[key].last
    BufferTable[key].eval = BufferTable[key].diff >= BufferTable[key].buffer
    if BufferTable[key].eval then BufferTable[key].last = BufferTable[key].now end
    return BufferTable[key].eval
end

local defaults =
{
	offsetX = -100,
	offsetY = 0
}

function updateanchors()
    --Check that the images are initialised first
    if not arrForward == nil then
        arrForward:SetAnchor(CENTER,GuiRoot,CENTER,savedVarsFTL.offsetX , savedVarsFTL.offsetY)
        arrForwardRight:SetAnchor(CENTER,GuiRoot,CENTER,savedVarsFTL.offsetX , savedVarsFTL.offsetY)
        arrRight:SetAnchor(CENTER,GuiRoot,CENTER,savedVarsFTL.offsetX , savedVarsFTL.offsetY)
        arrBackRight:SetAnchor(CENTER,GuiRoot,CENTER,savedVarsFTL.offsetX , savedVarsFTL.offsetY)
        arrBack:SetAnchor(CENTER,GuiRoot,CENTER,savedVarsFTL.offsetX , savedVarsFTL.offsetY)
        arrBackLeft:SetAnchor(CENTER,GuiRoot,CENTER,savedVarsFTL.offsetX , savedVarsFTL.offsetY)
        arrLeft:SetAnchor(CENTER,GuiRoot,CENTER,savedVarsFTL.offsetX , savedVarsFTL.offsetY)
        arrForwardLeft:SetAnchor(CENTER,GuiRoot,CENTER,savedVarsFTL.offsetX , savedVarsFTL.offsetY)
    end
end

local function OnAddOnLoaded(eventCode, addOnName)
    if(addOnName == "FollowTheLeader") then
	--SAVEDVARIABLES_DB used in the fire part of ZO_SavedVars:NewAccountWide
        savedVarsFTL = ZO_SavedVars:NewAccountWide("FOLLOWTHELEADER_DB", 1, nil, defaults)
        updateanchors()

    end
end

-- If Reticle is hidden then hide stuff also updates the images location incase the user changed settings
local function OnReticleHiddenF(eventcode)
	toggleimage(0)
    updateanchors()
end

-- Init FollowTheLeader
function FollowTheLeaderInit()
	EVENT_MANAGER:RegisterForEvent("FollowTheLeader", EVENT_ADD_ON_LOADED, OnAddOnLoaded)
	EVENT_MANAGER:RegisterForEvent("FollowTheLeader", EVENT_RETICLE_HIDDEN_UPDATE, OnReticleHiddenF)
	FollowTheLeaderConfigCPid = LAM:CreateControlPanel( 'followtheleaderconfigpanel', 'Follow The Leader' )
	LAM:AddHeader( FollowTheLeaderConfigCPid, 'followtheleaderconfigheader', 'Follow The Leader' )
    LAM:AddSlider(FollowTheLeaderConfigCPid, 'followtheleaderoffsetx', 'Horizontal Offset','Moves the leader pointer on the x axis',-1000,1000,10,  function() return savedVarsFTL.offsetX end, function(value) savedVarsFTL.offsetX = value end )
    LAM:AddSlider(FollowTheLeaderConfigCPid, 'followtheleaderoffsety', 'Vertical Offset','Moves the leader pointer on the y axis',-1000,1000,10,  function() return savedVarsFTL.offsetY end, function(value) savedVarsFTL.offsetY = value end )
end

local function NormalizeAngle(c)
    if c > math.pi then return c - 2 * math.pi end
    if c < -math.pi then return c + 2 * math.pi end
    return c
end

function toggleimage(imgx)
	if imgx == 1 then arrForward.icon:SetHidden(false) else arrForward.icon:SetHidden(true) end
	if imgx == 2 then arrForwardRight.icon:SetHidden(false) else arrForwardRight.icon:SetHidden(true) end
	if imgx == 3 then arrRight.icon:SetHidden(false) else arrRight.icon:SetHidden(true) end
	if imgx == 4 then arrBackRight.icon:SetHidden(false) else arrBackRight.icon:SetHidden(true) end
	if imgx == 5 then arrBack.icon:SetHidden(false) else arrBack.icon:SetHidden(true) end
	if imgx == 6 then arrBackLeft.icon:SetHidden(false) else arrBackLeft.icon:SetHidden(true) end
	if imgx == 7 then arrLeft.icon:SetHidden(false) else arrLeft.icon:SetHidden(true) end
	if imgx == 8 then arrForwardLeft.icon:SetHidden(false) else arrForwardLeft.icon:SetHidden(true) end
end

function FollowTheLeaderUpdate()
    local target = GetUnitName(GetGroupLeaderUnitTag())
    local ignore = ( target == "" or target == nil or not IsUnitOnline(GetGroupLeaderUnitTag()) or GetUnitName(GetGroupLeaderUnitTag()) == GetUnitName('player') or  IsReticleHidden() )

	if ignore then
		toggleimage(0)
	end

	if BufferReached("FollowTheLeaderupdatelead", .01) and not ignore then 
		-- GetGroupLeaderUnitTag()
		--and GetUnitZone("player") == GetUnitZone("reticleover") 
		playerH = NormalizeAngle(GetPlayerCameraHeading())
		local playerX, playerY, playerh = GetMapPlayerPosition('player')
		local targetX , targetY, targetH = GetMapPlayerPosition(GetGroupLeaderUnitTag())

		local dx = playerX - targetX
  		local dy = playerY - targetY
  		local targetangle = NormalizeAngle(playerH - math.atan2( dx, dy )) / math.pi
    	targetangle = math.floor(targetangle * 100)

		if targetangle >= -16 and targetangle <= 16 then 
			toggleimage(1)
		elseif targetangle >= 17 and targetangle <= 32 then 
			toggleimage(2)
		elseif targetangle >= 33 and targetangle <= 66 then 
			toggleimage(3)
		elseif targetangle >= 67 and targetangle <= 82 then 
			toggleimage(4)
		elseif (targetangle >= 83 and targetangle <= 10) or (targetangle >= -99 and targetangle <= -82) then 
			toggleimage(5)
		elseif targetangle >= -81 and targetangle <= -66 then 
			toggleimage(6)
		elseif targetangle >= -65 and targetangle <= -32 then 
			toggleimage(7)
		elseif targetangle >= -31 and targetangle <= -16 then 
			toggleimage(8)
		end
		--d(targetangle)
	end
    
end

